/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { ScatterBase } from "./ScatterBase";
import { DependencyProperty } from "igniteui-react-core";
import { Point_$type, typeCast, runOn, markType, markDep } from "igniteui-react-core";
import { ScatterFrame } from "./ScatterFrame";
import { ScatterSplineSeriesView } from "./ScatterSplineSeriesView";
import { Defaults } from "./Defaults";
import { Clipper } from "igniteui-react-core";
import { OwnedPoint } from "./OwnedPoint";
import { ScalerParams } from "./ScalerParams";
import { PathGeometry } from "igniteui-react-core";
import { Numeric } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
var ScatterSplineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterSplineSeries, _super);
    function ScatterSplineSeries() {
        var _this = _super.call(this) || this;
        _this.ab = ScatterSplineSeries.$;
        _this.vx = new ScatterFrame();
        _this.vz = new ScatterFrame();
        _this.vv = new ScatterFrame();
        return _this;
    }
    ScatterSplineSeries.prototype.bc = function () {
        return new ScatterSplineSeries();
    };
    ScatterSplineSeries.prototype.get_fe = function () {
        return true;
    };
    ScatterSplineSeries.prototype.cd = function () {
        return new ScatterSplineSeriesView(this);
    };
    ScatterSplineSeries.prototype.wr = function () {
        return true;
    };
    ScatterSplineSeries.prototype.iq = function () {
        if (!isNaN_(this.ip)) {
            return _super.prototype.iq.call(this);
        }
        return Defaults.x;
    };
    ScatterSplineSeries.prototype.pa = function (a, b, c, d) {
        _super.prototype.pa.call(this, a, b, c, d);
        switch (b) {
            case ScatterSplineSeries.$$p[0]:
                this.pr(false);
                this.om();
                break;
        }
    };
    ScatterSplineSeries.prototype.bu = function () {
        if (this.bv == 0) {
            return 2;
        }
        else {
            return _super.prototype.bu.call(this);
        }
    };
    ScatterSplineSeries.prototype.x8 = function (a, b) {
        var _this = this;
        _super.prototype.x8.call(this, a, b);
        a.m.clear();
        a.u.clear();
        var c = b.by;
        var d = b.bx;
        var e = this.getEffectiveViewport1(b);
        var f = this.hk * this.hk;
        var g = Math.min(this.wc != null ? this.wc.count : 0, this.wd != null ? this.wd.count : 0);
        var h = new ScalerParams(0, c, d, this.vr.d, e);
        var i = ((function () {
            var $ret = new ScalerParams(0, c, d, _this.vr.e, e);
            $ret.b = _this.h3();
            return $ret;
        })());
        var j = function (k) { return _this.vr.a.ej(_this.wc.item(k), h); };
        var k = function (l) { return _this.vr.b.ej(_this.wd.item(l), i); };
        var l = ((function () {
            var $ret = new Clipper(0, d, false);
            $ret.i = a.m;
            return $ret;
        })());
        for (var m = 0; m < g;) {
            var n = m;
            ++m;
            while (m < g && this.zg(j, k, n, m) < f) {
                ++m;
            }
            if (g > this.w3) {
                l.j(this.zk(j, k, n, m - 1));
            }
            else {
                var o = new OwnedPoint();
                o.c = { $type: Point_$type, x: j(n), y: k(n) };
                o.a = this.c7.item(n);
                if (!a.u.containsKey(o.a)) {
                    a.u.addItem(o.a, o);
                }
            }
        }
        if (g > this.w3) {
            l.i = null;
        }
    };
    ScatterSplineSeries.prototype.zk = function (a, b, c, d) {
        if (c == d) {
            return { $type: Point_$type, x: a(c), y: b(c) };
        }
        var e = 0;
        var f = 0;
        var g = (d - c + 1);
        for (var h = c; h <= d; ++h) {
            e += a(h);
            f += b(h);
        }
        return { $type: Point_$type, x: e / g, y: f / g };
    };
    ScatterSplineSeries.prototype.zg = function (a, b, c, d) {
        var e = a(d) - a(c);
        var f = b(d) - b(c);
        return e * e + f * f;
    };
    ScatterSplineSeries.prototype.get_wl = function () {
        return true;
    };
    ScatterSplineSeries.prototype.nk = function (a, b) {
        _super.prototype.nk.call(this, a, b);
        var c = typeCast(ScatterSplineSeriesView.$, b);
        c.c7(false);
    };
    ScatterSplineSeries.prototype.yj = function (a, b) {
        this.nk(false, b);
        _super.prototype.yj.call(this, a, b);
        this.yb(a);
        var c = typeCast(ScatterSplineSeriesView.$, b);
        var d = c.dj;
        this.v4.az(this, this.wq(), runOn(this, this.vk));
        var e = false;
        var f = this.v4.b;
        if (f != null) {
            e = true;
        }
        if (e) {
            this.x4(-1, this.wc.count, b.q);
        }
        this.v4.ad(d, true, false, true, false);
        c.dj.an = new PathGeometry();
        c.dj.an.c = Numeric.h(a.m.count, function (g) { return a.m._inner[g].x; }, function (g) { return a.m._inner[g].y; }, this.zh);
    };
    ScatterSplineSeries.$t = markType(ScatterSplineSeries, 'ScatterSplineSeries', ScatterBase.$);
    ScatterSplineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterSplineSeries, 'raisePropertyChanged', ['Stiffness:zh:zj', [1, 0.5]]);
    return ScatterSplineSeries;
}(ScatterBase));
export { ScatterSplineSeries };
